#ifndef _MEMINFO_H
#define _MEMINFO_H

#define MEMINFOPATH	"/dev/meminfo"

struct mempageinfo {
  pid_t		pid;	/* target process */
  unsigned long	addr;	/* target page address */
  int		npages;	/* maxmum number of pages to be stored */
  struct mempageinfo_struct *page;
};

struct mempageinfo_struct {
  union {
    struct {
      unsigned available: 1;
      unsigned present:   1;
      unsigned dirty:     1;
      unsigned reserved:  5;
    } flags;
    unsigned char allflags;
  } u;
};

struct memvmainfo {
  pid_t		pid;	/* target process */
  int		offset;
  int		nvmas;	/* maxmum number of areas to be stored */
  struct memvmainfo_struct *vma;
};

struct memvmainfo_struct {
  char filename[256];	/* mapped file */
  unsigned long vm_start;
  unsigned long vm_end;
  unsigned long vm_flags;
};

/* ioctl interfaces */
#define GETMEMPAGEINFO	_IOWR('m' | 0x80, 1, struct mempageinfo)
#define GETMEMVMAINFO	_IOWR('m' | 0x80, 2, struct memvmainfo)

#endif
